【leetcode】【easy】235. Lowest Common Ancestor of a Binary Search Tree

235. Lowest Common Ancestor of a Binary Search Tree

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”

Given binary search tree:  root = [6,2,8,0,4,7,9,null,null,3,5]

Example 1:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6
Explanation: The LCA of nodes 2 and 8 is 6

Example 2:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

Note:

  • All of the nodes' values will be unique.
  • p and q are different and both values will exist in the BST.

题目链接:https://leetcode-cn.com/problems/lowest-common-ancestor-of-a-binary-search-tree/

思路

由于是二叉搜索树,由二叉搜索树的性质辅助判断。

法一:递归

/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        if(!root || !p || !q) return NULL;
        if(p->val==root->val || q->val==root->val 
        || ((p->val < root->val)!=(q->val < root->val))) return root;
        else{
            if(p->val<root->val) return lowestCommonAncestor(root->left, p, q);
            else return lowestCommonAncestor(root->right, p, q);
        }
    }
};

法二:非递归

/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        if(!root || !p || !q) return NULL;
        while(root){
            if(p->val==root->val || q->val==root->val 
            || ((p->val < root->val)!=(q->val < root->val))) return root;
            if(p->val<root->val) root = root->left;
            else root = root->right;
        }
        return NULL;
    }
};
发布了126 篇原创文章 · 获赞 2 · 访问量 3737

猜你喜欢

转载自blog.csdn.net/lemonade13/article/details/104413163